#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#define MS 101
#define MT 151

int pol[MS][MT], outm[MS][MT], oute[MS][MT], pre[MS][MT];
int lcm[MS][MS], gcd[MS][MS];
int ant[MS][MS][MT], scon[MS][MS][MT];
int con[MS][MS][MS][MT];
int pt[MS];
int inv[MT];
int ec,ms,mt,p,broj;

void writepol (int[][MT]);
void writemat (int[][MT]);
void polexp (int[][MT],int,int);
void polmult (int[][MT],int[][MT],int,int);
void conn (int, int, int, int, int);
void euler (int[][MT]);


int main()
    {
	time_t start,end;
	double dif;
	int i,j,a,b,s,t,c,zad,fal,sum,cc,sums,sumt,num;
	short sig;
    
	//Input
	printf("This program counts the number of graphs without odd symmetry on vertices (taking into account dirrection of edges), with e edges and v vertices such that every vertex is at least 3-valent (without multiple edges), and calculates the Euler characteristic for fixed e-v, both for all graphs and only connected graphs.\n\nOdd*\n\n");
	printf("e-v is at most:\n");
	scanf("%d",&ec);
	printf("%d\n",ec);
	ms=2*ec;
	mt=3*ec;
	printf("Write a prime number greather than %d:\n",mt);
	scanf("%d",&p);
	printf("%d\n",p);
	
	time (&start);

	//inverting
	for (i=1;(i<=mt) || (i==4);i++)
	    {
        for (j=1;j%i!=0;j=j+p);
        inv[i]=j/i;
        }
	
	//LCM & GCD
	for (i=1;i<=ms;i++)
	    {
        gcd[i][i]=i;
        lcm[i][i]=i;
        }
	for (i=1;i<ms;i++) for (j=i+1;j<=ms;j++)
	    {
        gcd[i][j]=gcd[i][j-i];
        gcd[j][i]=gcd[i][j];
        lcm[i][j]=i*j/gcd[i][j];
        lcm[j][i]=lcm[i][j];
        }
    
	//connections
	for (a=1;2*a<ms;a++) for (b=a+1;a+b<=ms;b++)
        {
        for (s=0;s<=ms;s++) for (t=0;t<=mt;t++) con[a][b][s][t]=0;

        for (c=1;c*lcm[a][b]<=mt;c++)
            {
            sig=c%2;
            sig=-2*sig+1;
            con[a][b][0][c*lcm[a][b]] = (con[a][b][0][c*lcm[a][b]] - sig*gcd[a][b]*inv[c]) % p;
            }

        for (c=1;c*lcm[a][b]<=mt;c++) for (i=1;(i*c*lcm[a][b]<=ms) && ((i+1)*c*lcm[a][b]<=mt);i++)
            {
            sig=(i%2)*(c%2)*(lcm[a][b]%2);
            sig=-2*sig+1;
            con[a][b][i*c*lcm[a][b]][(i+1)*c*lcm[a][b]] = (con[a][b][i*c*lcm[a][b]][(i+1)*c*lcm[a][b]] + sig*gcd[a][b]*inv[c]) % p;
            }
        
	    //printf("con(%d,%d) = ",a,b);
        //writepol (con[a][b]);
        }

	//self connections
	for (a=1;2*a<=ms;a++)
	    {
        for (s=0;s<=ms;s++) for (t=0;t<=mt;t++) scon[a][s][t]=0;

        for (c=1;c*a<=mt;c++)
            {
            sig=c%2;
            sig=-2*sig+1;
            scon[a][0][c*a] = (scon[a][0][c*a] - sig*a*inv[c]) % p;
            }

        for (c=1;c*a<=mt;c++) for (i=1;(i*c*a<=ms) && ((i+1)*c*a<=mt);i++)
            {
            sig=(i%2)*(c%2)*(a%2);
            sig=-2*sig+1;
            scon[a][i*c*a][(i+1)*c*a] = (scon[a][i*c*a][(i+1)*c*a] + sig*a*inv[c]) % p;
            }
	    }

	//antenas
    for (a=1;a<=ms;a++)
	    {
        for (s=0;s<=ms;s++) for (t=0;t<=mt;t++) ant[a][s][t]=0;
        
        for (c=1;c*a<=ms;c++) for (i=1;c*a*i<=ms;i++)
        	{
        	sig=(i%2)*(c%2)*(a%2);
        	sig=-2*sig+1;
        	ant[a][c*a*i][c*a*i] = (ant[a][c*a*i][c*a*i] + sig*inv[c]) % p;
        	}
        for (c=1;2*c*a<=mt;c++) for (i=1;(c*a*i<=ms) && (c*a*(i+1)<=mt);i++)
            {
        	sig=(i%2)*(c%2)*(a%2);
            sig=-2*sig+1;
            ant[a][c*a*i][c*a*(i+1)] = (ant[a][c*a*i][c*a*(i+1)] + sig*((inv[2]*a)%p)*inv[c]) % p;
            }
        for (c=1;2*c*a<=mt;c++)
            {
        	sig=(c%2)*(a%2);
        	sig=-2*sig+1;
            ant[a][c*a][2*c*a] = (ant[a][c*a][2*c*a] - sig*inv[2]*inv[c]) % p;
            }
	    }

    //antenas on odd cycles
    for (a=1;a<=ms;a+=2)
    	{
    	for (c=1;c*a<=mt;c++)
    		{
    		sig=c%2;
    		sig=-2*sig+1;
    		ant[a][0][c*a] = (ant[a][0][c*a]+(1-a)/2*sig*inv[c]) % p;
    		}
    	for (c=1;3*c*a<=mt;c++) for (i=1;(2*c*a*i<=ms) && (c*a*(2*i+1)<=mt);i++)
    		{
    		ant[a][2*c*a*i][c*a*(2*i+1)] = (ant[a][2*c*a*i][c*a*(2*i+1)] - inv[2]*inv[c]) % p;
    		}
    	for (c=1;3*c*a<=ms;c++) for (i=1;(c*a*(2*i+1)<=ms) && (2*c*a*(i+1)<=mt);i++)
    		{
    		sig=c%2;
    		sig=-2*sig+1;
    		ant[a][c*a*(2*i+1)][2*c*a*(i+1)] = (ant[a][c*a*(2*i+1)][2*c*a*(i+1)] + sig*inv[2]*inv[c]) % p;
    		}
    	}

    //antenas on even cycles
    for (a=2;a<=ms;a+=2)
    	{
    	for (c=1;c*a<=mt;c++)
    		{
    		sig=c%2;
    		sig=-2*sig+1;
    		ant[a][0][c*a] = (ant[a][0][c*a] - sig*(a-2)/2*inv[c]) % p;
    		}
    	for (c=1;c*a/2<=mt;c++)
    		{
    		ant[a][0][c*a/2] = (ant[a][0][c*a/2] - inv[c]) % p;
    		}
    	for (c=1;(2*c-1)*a<=mt;c++)
    		{
    		sig=(a/2)%2;
    		sig=-2*sig+1;
    		ant[a][(2*c-1)*a/2][(2*c-1)*a] = (ant[a][(2*c-1)*a/2][(2*c-1)*a] + sig*inv[(2*c-1)]) % p;
    		}
    	for (c=1;c*a/2<=mt;c++) for (i=1;(c*a*i<=ms) && (c*(a*i+a/2)<=mt);i++)
    		{
    		ant[a][c*a*i][c*(a*i+a/2)] = (ant[a][c*a*i][c*(a*i+a/2)] - inv[c]) % p;
    		}
    	for (c=1;c*a<=mt;c++) for (i=1;(c*(a*i+a/2)<=ms) && (c*a*(i+1)<=mt);i++)
    		{
    		sig=(c%2)*((a/2)%2);
    		sig=-2*sig+1;
    		ant[a][c*(a*i+a/2)][c*a*(i+1)] = (ant[a][c*(a*i+a/2)][c*a*(i+1)] + sig*inv[c]) % p;
    		}
    	}
    
    //Partitions
    for (i=0;i<=ms;i++)
        {
        pt[i]=0;
        }
	pt[ms]=1;
	zad=ms;
	fal=0;
	for (s=0;s<=ms;s++) for (t=0;t<=mt;t++) pol[s][t]=0;
	pol[0][0]=1;
    
    while (zad>0)
		{
        cc=1;
        for (a=1;a<=zad;a++)
        	{
        	sig=a%2;
        	sig=-2*sig+1;
        	for (i=1;i<=pt[a];i++) cc = (((-sig*cc*inv[i])%p)*inv[a])%p;
        	}
        
        for (s=0;s<=ms;s++) for (t=0;t<=mt;t++) pre[s][t]=0;
        for (a=1;a<=zad;a++) for (b=1;b<=zad;b++) for (s=0;s<=ms;s++) for (t=0;t<=mt;t++) pre[s][t] = (pre[s][t] + pt[a]*pt[b]*con[a][b][s][t]) % p;
        for (a=1;a<=zad;a++) for (s=0;s<=ms;s++) for (t=0;t<=mt;t++) if (pt[a]>1) pre[s][t] = (pre[s][t] + pt[a]*(pt[a]-1)/2*scon[a][s][t]) % p;
        for (a=1;a<=zad;a++) for (s=0;s<=ms;s++) for (t=0;t<=mt;t++) pre[s][t] = (pre[s][t] + pt[a]*ant[a][s][t]) % p;
        
        polexp (pre,fal,mt);
        
        /*
        broj=1;
        if (pt[1]!=3) broj=0;
        if (pt[2]!=0) broj=0;
        for (i=3;i<=ms;i++)
            {
            if (pt[i]!=0) broj=0;
            }
        if (broj==1) writemat (oute);
        */

        sum=ms-fal;
        for (s=sum;s<=ms;s++) for (t=0;t<=mt;t++)
            {
            pol[s][t] = (pol[s][t] + cc*oute[s-sum][t]) % p;
            }
        
		if (fal>=zad)
			{
			pt[fal]++;
			zad=fal;
			fal=0;
			} else
			{
			fal=fal+zad*pt[zad];
			pt[zad]=0;
			zad--;
			fal=fal-zad;
			pt[zad]++;
			}
		}
    
	//Vakuum
	for (s=0;s<=ms;s++) for (t=0;t<=mt;t++) pre[s][t]=0;

	for (c=1;c*3<=ms;c++) for (i=3;c*i<=ms;i++)
	    {
        sig=(i%2)*(c%2);
        sig=-2*sig+1;
        pre[c*i][c*i] = (pre[c*i][c*i] + sig*inv[2]*inv[i]) % p;
        }
	for (c=1;(2*c-1)*2<=ms;c++) for (i=2;(2*c-1)*i<=ms;i++)
	    {
        sig=i%2;
        sig=-2*sig+1;
        pre[(2*c-1)*i][(2*c-1)*(i-1)] = (pre[(2*c-1)*i][(2*c-1)*(i-1)] + sig*inv[2]*inv[2*c-1]) % p;
        }
    for (c=1;2*c*2<=ms;c++) for (i=0;2*c*(i+2)<=ms;i++)
	    {
        pre[2*c*(i+2)][2*c*(i+1)] = (pre[2*c*(i+2)][2*c*(i+1)] + inv[4]*inv[c]) % p;
        pre[2*c*(i+2)][2*c*(i+2)] = (pre[2*c*(i+2)][2*c*(i+2)] + inv[4]*inv[c]) % p;
        pre[2*c*(i+2)][c*(2*i+3)] = (pre[2*c*(i+2)][c*(2*i+3)] - inv[2]*inv[c]) % p;
        }
	for (c=1;c*3<=ms;c++) for (i=0;c*(2*i+3)<=ms;i++)
	    {
        sig=c%2;
        sig=-2*sig+1;
        pre[c*(2*i+3)][2*c*(i+1)] = (pre[c*(2*i+3)][2*c*(i+1)] + sig*inv[2]*inv[c]) % p;
        pre[c*(2*i+3)][c*(2*i+3)] = (pre[c*(2*i+3)][c*(2*i+3)] - sig*inv[2]*inv[c]) % p;
        }
	for (c=1;2*c<=ms;c++) for (i=0;2*c*(i+1)<=ms;i++)
	    {
        pre[2*c*(i+1)][2*c*(i+1)] = (pre[2*c*(i+1)][2*c*(i+1)] + inv[4]*inv[c]) % p;
        }
	for (c=1;2*c<=ms;c++)
	    {
        pre[2*c][2*c] = (pre[2*c][2*c] + (c-2)*((inv[4]*inv[c])%p)) % p;
        }
	for (c=1;2*c<=ms;c++)
	    {
        pre[2*c][2*c] = (pre[2*c][2*c] + ((inv[2]*inv[c])%p)*(c-1)) % p;
        }	
	for (c=1;2*c-1<=ms;c++)
	    {
        pre[2*c-1][2*c-1] = (pre[2*c-1][2*c-1] - inv[2*c-1]*(c-1)) % p;
        }
	for (c=1;2*c<=ms;c++)
	    {
        pre[2*c][c] = (pre[2*c][c] - inv[2]*inv[c]) % p;
        }
	for (c=1;c<=ms;c++)
	    {
        sig=c%2;
        sig=-2*sig+1;
        pre[c][0] = (pre[c][0] + sig*inv[c]) % p;
        }
    
	polexp (pre,ms,mt);


	//Final polynomial
	polmult (pol,oute,ms,mt);
	for (s=0;s<=ms;s++) for (t=0;t<=mt;t++)
		{
		pol[s][t]=outm[s][t] % p;
		if (pol[s][t]<0) pol[s][t]+=p;
		}

	//Time
	time (&end);
	dif = difftime (end,start);
	printf ("\nCalculation took %.2lf seconds to run.\n", dif);
	time (&start);

	//Printing result with disconnected graphs
	printf ("\nWith disconnected graphs:\n");
	writemat (pol);
	euler (pol);

	//Connected part
	for (s=4;s+4<=ms;s++) for (t=(3*s+1)/2;t+6<=mt;t++) for (i=1;(s*i<=ms) && (t*i<=mt);i++)
		{
		sums=s*i;
		sumt=t*i;
		num=1;
		for (j=1;j<=i;j++)
			{
			if (s%2==0) num = (num*(pol[s][t]+j-1)*inv[j]) % p;
			else num = (num*(pol[s][t]-j+1)*inv[j]) % p;
			}
		if (i>1) pol[sums][sumt] = (pol[sums][sumt] - num) % p;
		conn (s,t,sums,sumt,num);
		}
	
	for (s=0;s<=ms;s++) for (t=0;t<=mt;t++)
		{
		pol[s][t]=pol[s][t] % p;
		if (pol[s][t]<0) pol[s][t]+=p;
		}

	//Printing result for connected graphs
	printf ("\n\nOnly connected graphs:\n");
	writemat (pol);
	euler (pol);

    fflush(stdin);
    getchar();
    return 0;
}


void polmult (int aa[][MT], int bb[][MT], int mms, int mmt)
{
    int i,j,s,t;
    
    for (s=0;s<=mms;s++) for (t=0;t<=mmt;t++)
        {
        outm[s][t]=0;
        for (i=0;i<=s;i++) for (j=0;j<=t;j++) outm[s][t] += aa[i][j]*bb[s-i][t-j];
	outm[s][t] %= p;
        }
}

void polexp (int aa[][MT], int mms, int mmt)
{
    int rad[MS][MT];
    int min=mmt;
    int i,s,t;
    
    for (s=0;s<=mms;s++) for (t=0;t<=mmt;t++)
        {
        if ((aa[s][t]!=0) && (s<min) && (t<min))
           {
           if (s<t) min=t; else min=s;
           }
        oute[s][t]=aa[s][t];
        rad[s][t]=aa[s][t];
        }
    oute[0][0]=1;
    
    for (i=2;i*min<=mmt;i++)
        {        
        polmult (rad,aa,mms,mmt);
        for (s=0;s<=mms;s++) for (t=0;t<=mmt;t++)
            {
            rad[s][t]=(inv[i]*outm[s][t])%p;
            oute[s][t] = (oute[s][t] + rad[s][t]) % p;
            }
        }
}


void conn (int ss, int tt,int sums,int sumt,int numm)
{
	int i,j,s,t,num;

	s=ss;
	for (t=(3*s+1)/2;t<tt;t++) for (i=1;(sums+s*i<=ms) && (sumt+t*i<=mt);i++)
		{
		num=numm;
		for (j=1;j<=i;j++)
			{
			if (s%2==0) num = (num*(pol[s][t]+j-1)*inv[j]) % p;
			else num = (num*(pol[s][t]-j+1)*inv[j]) % p;
			}
		pol[sums+s*i][sumt+t*i] = (pol[sums+s*i][sumt+t*i] - num) % p;
		if (sums+s*i+4<=ms) conn (s,t,sums+s*i,sumt+t*i,num);
		}
	for (s=4;s<ss;s++) for (t=(3*s+1)/2;sumt+t<=mt;t++) for (i=1;(sums+s*i<=ms) && (sumt+t*i<=mt);i++)
		{
		num=numm;
		for (j=1;j<=i;j++)
			{
			if (s%2==0) num = (num*(pol[s][t]+j-1)*inv[j]) % p;
			else num = (num*(pol[s][t]-j+1)*inv[j]) % p;
			}
		pol[sums+s*i][sumt+t*i] = (pol[sums+s*i][sumt+t*i] - num) % p;
		if (sums+s*i+4<=ms) conn (s,t,sums+s*i,sumt+t*i,num);
		}
}


void writepol (int aa[][MT])
{
   	int contt, conts;
   	int s,t;
   	
   	conts=0;
   	
    for (s=0;s<=ms;s++)
        {
        contt=0;
        
        for (t=0;t<=mt;t++)
            {
            if (aa[s][t]!=0) contt++;
            }
        
        if (contt>0)
           {
           if (conts==1) printf(" + ");
           conts=1;
           
           printf("(");
           for (t=0;aa[s][t]==0;t++);
           if (aa[s][t]==-1) printf("-");
           if (abs(aa[s][t])!=1) printf("%d",aa[s][t]);
           if (t>0) printf("t");
           if (t>1) printf("^%d",t);
           if ((t==0) && (abs(aa[s][0])==1)) printf ("1");
           
           for (t++;t<=mt;t++) if (aa[s][t]!=0)
               {
               if (aa[s][t]>0) printf (" + "); else printf(" - ");
               if (abs(aa[s][t])!=1) printf("%d",abs(aa[s][t]));
               if (t>0) printf("t");
               if (t>1) printf("^%d",t);
               }
           printf(")");
           if (s>0) printf("s^%d",s);
           }
        }
    printf("\n");
}

void euler (int aa[][MT])
{
    int i,j,out,sig;
    
    printf ("\ne-v : Euler characteristic\n");
    for (i=0;i<=ec;i++)
        {
        if (i<10) printf (" ");
    	printf (" %d : ",i);
        out=0;
        sig=1;
        for (j=0;j<=ms;j++)
            {
            out+=sig*aa[j][i+j];
            sig=-sig;
            }
        out=out%p;
        if (out<0) out+=p;
        if (out>p/2) out-=p;
        printf ("%d\n",out);
        }
}


void writemat (int aa[][MT])
{
   	int s,t;
   	
   	printf ("\n");
   	for (t=mt;t>=0;t--)
        {
        printf ("%d",aa[0][t]);
        for (s=1;s<=ms;s++)
            {
            printf (" ");
            if (aa[s][t]<10) printf (" ");
            if ((aa[s][t]<100) && (p>100)) printf (" ");
            printf ("%d",aa[s][t]);
            }
        printf ("\n");
        }
}
